

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Configured Shyft simulations &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
        <script type="text/x-mathjax-config">MathJax.Hub.Config({"tex2jax": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true, "ignoreClass": "document", "processClass": "math|output_area"}})</script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="A first simulation with Shyft" href="run_nea_nidelva.html" />
    <link rel="prev" title="Running a calibration with SHyFT" href="calibration-configured.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../content/hydrology/getting_started.html">Getting started</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#general-examples">General examples</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../../content/hydrology/getting_started.html#configured-simulation">Configured simulation</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="calibration-configured.html">Running a calibration with SHyFT</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Configured Shyft simulations</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#Introduction">Introduction</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#This-notebook-briefly-runs-through-the-simulation-process-for-a-pre-configured-catchment.-The-following-steps-are-described:">This notebook briefly runs through the simulation process for a pre-configured catchment. The following steps are described:</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">1. Loading required python modules and setting path to SHyFT installation</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#The-Shyft-Environment">The Shyft Environment</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#2.-Configuration-of-a-SHyFT-simulation">2. Configuration of a SHyFT simulation</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#The-simulator-and-the-region_model">The simulator and the region_model</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#3.-Running-a-SHyFT-simulation">3. Running a SHyFT simulation</a></li>
<li class="toctree-l4"><a class="reference internal" href="#4.-Post-processing-and-data-extraction">4. Post processing and data extraction</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#Visualizing-the-discharge-for-each-[sub-]catchment">Visualizing the discharge for each [sub-]catchment</a><ul>
<li class="toctree-l6"><a class="reference internal" href="#Look-at-the-discharge-timeseries">Look at the discharge timeseries</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="#Visualizing-the-distributed-catchment-data">Visualizing the distributed catchment data</a><ul>
<li class="toctree-l6"><a class="reference internal" href="#Extract-data-for-individual-simulation-cells">Extract data for individual simulation cells</a></li>
</ul>
</li>
<li class="toctree-l5"><a class="reference internal" href="#Visualing-the-Snow-Cover-Area-of-all-cells-for-a-certain-point-in-time">Visualing the Snow Cover Area of all cells for a certain point in time</a><ul>
<li class="toctree-l6"><a class="reference internal" href="#A-note-about-the-geometry-of-the-region">A note about the geometry of the region</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="run_nea_nidelva.html">A first simulation with Shyft</a></li>
<li class="toctree-l3"><a class="reference internal" href="advanced_simulation.html">Simulation with the Shyft API</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#advanced-tools">Advanced tools</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../content/hydrology/getting_started.html">Getting started</a> &raquo;</li>
        
      <li>Configured Shyft simulations</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/notebooks/nea-example/simulation-configured.ipynb.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}

/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="Configured-Shyft-simulations">
<h1>Configured Shyft simulations<a class="headerlink" href="#Configured-Shyft-simulations" title="Permalink to this headline">¶</a></h1>
<div class="section" id="Introduction">
<h2>Introduction<a class="headerlink" href="#Introduction" title="Permalink to this headline">¶</a></h2>
<p>Shyft provides a toolbox for running hydrologic simulations. As it was designed to work in an operational environment, we’ve provided several different workflows for running a model simulation. The main concept to be aware of is that while we demonstrate and build on the use of a ‘configuration’, nearly all simulation functionality is also accessible with pure python through access to the <code class="docutils literal notranslate"><span class="pre">API</span></code>. This is the <em>encouraged</em> approach to simulation. The use of <em>configurations</em> is intended to be a
mechanism of running repeated operational simulations when one is interested in archiving and storing (potentially to a database) the specifics of the simulation.</p>
<p>Below we start with a high level description using a configuration object, and in <a class="reference internal" href="advanced_simulation.html"><span class="doc">Part II</span></a> of the simulation notebooks we describe the approach using the lower level APIs. It is recommended, if you intend to use Shyft for any kind of hydrologic exploration, to become familiar with the API functionality.</p>
<div class="section" id="This-notebook-briefly-runs-through-the-simulation-process-for-a-pre-configured-catchment.-The-following-steps-are-described:">
<h3>This notebook briefly runs through the simulation process for a pre-configured catchment. The following steps are described:<a class="headerlink" href="#This-notebook-briefly-runs-through-the-simulation-process-for-a-pre-configured-catchment.-The-following-steps-are-described:" title="Permalink to this headline">¶</a></h3>
<ol class="arabic simple">
<li><p><strong>Loading required python modules and setting path to Shyft installation</strong></p></li>
<li><p><strong>Configuration of a Shyft simulation</strong></p></li>
<li><p><strong>Running a Shyft simulation</strong></p></li>
<li><p><strong>Post-processing:</strong> Fetching simulation results from the simulator-object.</p></li>
</ol>
</div>
</div>
<div class="section" id="1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">
<h2>1. Loading required python modules and setting path to SHyFT installation<a class="headerlink" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation" title="Permalink to this headline">¶</a></h2>
<p>Shyft requires a number of different modules to be loaded as part of the package. Below, we describe the required steps for loading the modules, and note that some steps are only required for the use of the jupyter notebook.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Pure python modules and jupyter notebook functionality</span>
<span class="c1"># first you should import the third-party python modules which you&#39;ll use later on</span>
<span class="c1"># the first line enables that figures are shown inline, directly in the notebook</span>
<span class="o">%</span><span class="k">pylab</span> inline
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">datetime</span> <span class="k">as</span> <span class="nn">dt</span>
<span class="kn">from</span> <span class="nn">os</span> <span class="kn">import</span> <span class="n">path</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">pyplot</span> <span class="k">as</span> <span class="n">plt</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Populating the interactive namespace from numpy and matplotlib
</pre></div></div>
</div>
<div class="section" id="The-Shyft-Environment">
<h3>The Shyft Environment<a class="headerlink" href="#The-Shyft-Environment" title="Permalink to this headline">¶</a></h3>
<p>This next step is highly specific on how and where you have installed Shyft. If you have followed the guidelines at github, and cloned the three shyft repositories: i) shyft, ii) shyft-data, and iii) shyft-doc, then you may need to tell jupyter notebooks where to find shyft. Uncomment the relevant lines below.</p>
<p>If you have a ‘system’ shyft, or used <code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">install</span> <span class="pre">-s</span> <span class="pre">sigbjorn</span> <span class="pre">shyft</span></code> to install shyft, then you probably will want to make sure you have set the SHYFTDATA directory correctly, as otherwise, Shyft will assume the above structure and fail. <strong>This has to be done before ``import shyft``</strong>. In that case, uncomment the relevant lines below.</p>
<p><strong>note</strong>: it is most likely that you’ll need to do one <em>or</em> the other.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># try to auto-configure the path, -will work in all cases where doc and data</span>
<span class="c1"># are checked out at same level</span>
<span class="n">shyft_data_path</span> <span class="o">=</span> <span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s2">&quot;../../../shyft-data&quot;</span><span class="p">)</span>
<span class="k">if</span> <span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">shyft_data_path</span><span class="p">)</span> <span class="ow">and</span> <span class="s1">&#39;SHYFT_DATA&#39;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">[</span><span class="s1">&#39;SHYFT_DATA&#39;</span><span class="p">]</span><span class="o">=</span><span class="n">shyft_data_path</span>

<span class="c1"># shyft should be available either by it&#39;s install in python</span>
<span class="c1"># or by PYTHONPATH set by user prior to starting notebook.</span>
<span class="c1"># This is equivalent to the two lines below</span>
<span class="c1">#  shyft_path=path.abspath(&#39;../../../shyft&#39;)</span>
<span class="c1">#  sys.path.insert(0,shyft_path)</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># once the shyft_path is set correctly, you should be able to import shyft modules</span>

<span class="kn">import</span> <span class="nn">shyft</span>

<span class="c1"># if you have problems here, it may be related to having your LD_LIBRARY_PATH</span>
<span class="c1"># pointing to the appropriate libboost_python libraries (.so files)</span>
<span class="kn">from</span> <span class="nn">shyft</span> <span class="kn">import</span> <span class="n">api</span>
<span class="kn">from</span> <span class="nn">shyft.repository.default_state_repository</span> <span class="kn">import</span> <span class="n">DefaultStateRepository</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.configuration.yaml_configs</span> <span class="kn">import</span> <span class="n">YAMLSimConfig</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.simulators.config_simulator</span> <span class="kn">import</span> <span class="n">ConfigSimulator</span>
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="2.-Configuration-of-a-SHyFT-simulation">
<h2>2. Configuration of a SHyFT simulation<a class="headerlink" href="#2.-Configuration-of-a-SHyFT-simulation" title="Permalink to this headline">¶</a></h2>
<p>The following shows how to set up a Shyft simulation using the <code class="docutils literal notranslate"><span class="pre">yaml_configs.YAMLSimConfig</span></code> class. Note that this is a <strong>high level</strong> approach, providing a working example for a simple simulation. More advanced users will want to eventually make use of direct API calls, as outlined in <a class="reference internal" href="advanced_simulation.html"><span class="doc">Part II</span></a>.</p>
<p>At this point, you may want to have a look to the <a class="reference external" href="nea-config/neanidelva_simulation.yaml">configuration file</a> used in this example.</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>---
neanidelva:
  region_config_file: neanidelva_region.yaml
  model_config_file: neanidelva_model_calibrated.yaml
  datasets_config_file: neanidelva_datasets.yaml
  interpolation_config_file: neanidelva_interpolation.yaml
  start_datetime: 2013-09-01T00:00:00
  run_time_step: 86400  # 1 day time step
  number_of_steps: 365  # 1 year
  region_model_id: &#39;neanidelva-ptgsk&#39;
  #interpolation_id: 2   # this is optional (default 0)
  initial_state:
    repository:
      class: !!python/name:shyft.repository.generated_state_repository.GeneratedStateRepository
      params:
        model: !!python/name:shyft.api.pt_gs_k.PTGSKModel
    tags: []
...
</pre></div>
</div>
<p>The file is structured as follows:</p>
<p><code class="docutils literal notranslate"><span class="pre">neanidelva</span></code> is the name of the simulation. Your configuration file may contain multiple “stanzas” or blocks of simulation configurations. You’ll see below that we use the name to instantiate a configuration object.</p>
<p><code class="docutils literal notranslate"><span class="pre">region_config_file</span></code> points to another yaml file that contains basic information about the region of the simulation. You can <a class="reference external" href="nea-config/neanidelva_region.yaml">explore that file here</a></p>
<p><code class="docutils literal notranslate"><span class="pre">model_config_file</span></code> contains the model parameters. Note that when you are calibrating the model, <a class="reference external" href="nea-config/neanidelva_model_calibrated.yaml">this is the file</a> that you would put your optimized parameters into once you have completed a calibrations.</p>
<p><code class="docutils literal notranslate"><span class="pre">datasets_config_file</span></code> contains details regarding the input datasets and the <a class="reference external" href="../../repositories.rst">repositories</a> they are contained in. You can see <a class="reference external" href="nea-config/neanidelva_datasets.yaml">this file here</a></p>
<p><code class="docutils literal notranslate"><span class="pre">interpolation_config_file</span></code> provides details regarding how the observational data in your catchment or region will be interpolated to the domain of the simulation. If you are using a repository with distributed data, the interpolation is still used. <a class="reference external" href="nea-config/neanidelva_interpolation.yaml">See this file</a> for more details.</p>
<p>The following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>start_datetime: 2013-09-01T00:00:00
run_time_step: 86400  # 1 hour time step
number_of_steps: 365  # 1 year
region_model_id: &#39;neanidelva-ptgsk&#39;
</pre></div>
</div>
<p>are considered self-explantory. Note that <code class="docutils literal notranslate"><span class="pre">region_model_id</span></code> is simply a string name, but it should be <strong>unique</strong>. We will explain the details regarding <code class="docutils literal notranslate"><span class="pre">initial_state</span></code> later on in this tutorial.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># set up configuration using *.yaml configuration files</span>
<span class="c1"># here is the *.yaml file that configures the simulation:</span>
<span class="n">config_file_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s2">&quot;./nea-config/neanidelva_simulation.yaml&quot;</span><span class="p">)</span>

<span class="c1"># and here we pass it to the configurator, together with the name of the region</span>
<span class="c1"># stated in the simulation.yaml file (here: &quot;neanidelva&quot;) which we would like to run</span>
<span class="n">cfg</span> <span class="o">=</span> <span class="n">YAMLSimConfig</span><span class="p">(</span><span class="n">config_file_path</span><span class="p">,</span> <span class="s2">&quot;neanidelva&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="nb">print</span><span class="p">(</span><span class="n">cfg</span><span class="o">.</span><span class="n">datasets_config</span><span class="p">)</span>

</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
YamlContent(_config_file=&#39;/home/sih/projects/shyft-doc/notebooks/nea-example/nea-config/neanidelva_datasets.yaml&#39;, sources=[{&#39;repository&#39;: &lt;class &#39;shyft.repository.netcdf.cf_geo_ts_repository.CFDataRepository&#39;&gt;, &#39;types&#39;: [&#39;precipitation&#39;], &#39;params&#39;: {&#39;filename&#39;: &#39;netcdf/orchestration-testdata/precipitation.nc&#39;, &#39;padding&#39;: 0.0}}, {&#39;repository&#39;: &lt;class &#39;shyft.repository.netcdf.cf_geo_ts_repository.CFDataRepository&#39;&gt;, &#39;types&#39;: [&#39;temperature&#39;], &#39;params&#39;: {&#39;filename&#39;: &#39;netcdf/orchestration-testdata/temperature.nc&#39;, &#39;padding&#39;: 0.0}}, {&#39;repository&#39;: &lt;class &#39;shyft.repository.netcdf.cf_geo_ts_repository.CFDataRepository&#39;&gt;, &#39;types&#39;: [&#39;wind_speed&#39;], &#39;params&#39;: {&#39;filename&#39;: &#39;netcdf/orchestration-testdata/wind_speed.nc&#39;, &#39;padding&#39;: 0.0}}, {&#39;repository&#39;: &lt;class &#39;shyft.repository.netcdf.cf_geo_ts_repository.CFDataRepository&#39;&gt;, &#39;types&#39;: [&#39;relative_humidity&#39;], &#39;params&#39;: {&#39;filename&#39;: &#39;netcdf/orchestration-testdata/relative_humidity.nc&#39;, &#39;padding&#39;: 0.0}}, {&#39;repository&#39;: &lt;class &#39;shyft.repository.netcdf.cf_geo_ts_repository.CFDataRepository&#39;&gt;, &#39;types&#39;: [&#39;radiation&#39;], &#39;params&#39;: {&#39;filename&#39;: &#39;netcdf/orchestration-testdata/radiation.nc&#39;, &#39;padding&#39;: 0.0}}])
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Once we have all the configuration in place (read in from the .yaml files)</span>
<span class="c1"># we can start to do the simulation. Here we use the ConfigSimulator class</span>
<span class="c1"># to initialize a simulator-object. Shyft has several ways to achieve this</span>
<span class="c1"># but the .yaml configs are the most straight forward</span>

<span class="n">simulator</span> <span class="o">=</span> <span class="n">ConfigSimulator</span><span class="p">(</span><span class="n">cfg</span><span class="p">)</span>
<span class="c1"># Now the simulator is ready to run!</span>
</pre></div>
</div>
</div>
<div class="section" id="The-simulator-and-the-region_model">
<h3>The simulator and the region_model<a class="headerlink" href="#The-simulator-and-the-region_model" title="Permalink to this headline">¶</a></h3>
<p>It is important to note that the simulator provides a wrapping of underlying API functionality. It is designed to provide a quick and simple interface for conducting runs based on a configuration saved in a <code class="docutils literal notranslate"><span class="pre">.yaml</span></code> file, or otherwise. Core functionality is contained in the <code class="docutils literal notranslate"><span class="pre">region_model</span></code> which is just an instance of a model stack, or what is referred to as a <code class="docutils literal notranslate"><span class="pre">`model</span></code> &lt;../api/api-intro.ipynb#The-model-class&gt;`__ in the <code class="docutils literal notranslate"><span class="pre">api</span></code> intro notebook. This is an import concept in Shyft. To understand
the framework, one should be familiar with this class.</p>
<p>Before we begin the simulation, one should explore the <code class="docutils literal notranslate"><span class="pre">simulator</span></code> object with tab completion. As an example, you can see here how to get the number of cells in the region that was set up. This is used later for extracting the data.</p>
<p>Most importantly, understand the simulator has an attribute called <code class="docutils literal notranslate"><span class="pre">region_model</span></code>. Most of the underlying functionality of the <code class="docutils literal notranslate"><span class="pre">simulator</span></code> methods are actually making calls to the <code class="docutils literal notranslate"><span class="pre">region_model</span></code> which is an instantiation of one of Shyft’s “model stack” classes. To conduct more advanced simulations one would use this object directly.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1">#simulator.  #try tab completion</span>
<span class="n">n_cells</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">size</span><span class="p">()</span>
<span class="nb">print</span><span class="p">(</span><span class="n">n_cells</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
3874
</pre></div></div>
</div>
</div>
</div>
<div class="section" id="3.-Running-a-SHyFT-simulation">
<h2>3. Running a SHyFT simulation<a class="headerlink" href="#3.-Running-a-SHyFT-simulation" title="Permalink to this headline">¶</a></h2>
<p>Okay, so thus far we have set up our <code class="docutils literal notranslate"><span class="pre">cfg</span></code> object which contains most the information required to run the simulation. We can simply run the simulation using the <code class="docutils literal notranslate"><span class="pre">run</span></code> method.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">simulator</span><span class="o">.</span><span class="n">run</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area stderr docutils container">
<div class="highlight"><pre>
/home/sih/projects/shyft/shyft/repository/netcdf/utils.py:351: RuntimeWarning: invalid value encountered in greater
  pure_arr = nc_var[data_slice][tuple(xy_slice_mask)]
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Running simulation...
</pre></div></div>
</div>
<p>But this is may be too simple. Let’s explore the <code class="docutils literal notranslate"><span class="pre">simulator.run</span></code> method a bit further:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">help</span><span class="p">(</span><span class="n">simulator</span><span class="o">.</span><span class="n">run</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Help on method run in module shyft.orchestration.simulator:

run(time_axis=None, state=None) method of shyft.orchestration.simulators.config_simulator.ConfigSimulator instance
    Forward simulation over time axis

    Parameters
    ----------
    time_axis: shyft.api.TimeAxis
        Time axis defining the simulation period, and step sizes.
    state: shyft.api state

</pre></div></div>
</div>
<p>Note that you can pass two parameters to <code class="docutils literal notranslate"><span class="pre">run</span></code>. To run a simulation, we need a time_axis (length of the simulation), and an initial state. Initially we got both of these from the <code class="docutils literal notranslate"><span class="pre">cfg</span></code> object (which takes it from the .yaml files). However, in some cases you will likely want to change these and conduct simulations for different periods, or starting from different states. We explore this further in <a class="reference internal" href="advanced_simulation.html"><span class="doc">Part II: advanced simulation</span></a></p>
</div>
<div class="section" id="4.-Post-processing-and-data-extraction">
<h2>4. Post processing and data extraction<a class="headerlink" href="#4.-Post-processing-and-data-extraction" title="Permalink to this headline">¶</a></h2>
<p>You have now completed a simple simulation. You probably are interested to explore some of the output from the simulation and to visulize the quality of the results. Let’s explore first, how to access the underlying data produced from the simulation.</p>
<div class="section" id="Visualizing-the-discharge-for-each-[sub-]catchment">
<h3>Visualizing the discharge for each [sub-]catchment<a class="headerlink" href="#Visualizing-the-discharge-for-each-[sub-]catchment" title="Permalink to this headline">¶</a></h3>
<p>Recall that we earlier referred to the importance of understanding the <code class="docutils literal notranslate"><span class="pre">region_model</span></code>. You’ll see now that this is where information from the simulation is actually contained, and that the <code class="docutils literal notranslate"><span class="pre">simulator</span></code> object is more or less a convenience wrapper.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Here we are going to extact data from the simulator object.</span>
<span class="c1"># let&#39;s work directly with the `region_model`</span>
<span class="n">region_model</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model</span>

<span class="nb">print</span><span class="p">(</span><span class="n">region_model</span><span class="o">.</span><span class="n">catchment_ids</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[   1996    1867    1228    2446    2640    2129    2195    3536    3630
    2198    2718    2465    2402    1443    2277    2728    1308    3178
 1000011    1330    1966    2545    1394    2041    3002 1000010    1726]
</pre></div></div>
</div>
<p>We see here that each sub-catchment in our simulation is associated with a unique ID. These are user defined IDs. In the case of the nea-nidelva simulation, they are taken from the GIS database used to create the example configuration files.</p>
<p>To get data out of the <code class="docutils literal notranslate"><span class="pre">region_model</span></code> you need to specify which catchments you are interested in evaluating. In the following example we are going to extract the data for each catchment and make a simple plot.</p>
<p>Note that Shyft uses many specialized C++ types. Many of these have methods to convert to the more familiar <code class="docutils literal notranslate"><span class="pre">numpy</span></code> objects. An example may be the discharge timeseries for a catchment.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">q_1228_ts</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">([</span><span class="mi">1228</span><span class="p">])</span>
<span class="n">q_1228_np</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">([</span><span class="mi">1228</span><span class="p">])</span><span class="o">.</span><span class="n">values</span>
<span class="nb">print</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">q_1228_ts</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">q_1228_np</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;class &#39;shyft.time_series._time_series.TimeSeries&#39;&gt;
&lt;class &#39;shyft.time_series._time_series.DoubleVector&#39;&gt;
</pre></div></div>
</div>
<div class="section" id="Look-at-the-discharge-timeseries">
<h4>Look at the discharge timeseries<a class="headerlink" href="#Look-at-the-discharge-timeseries" title="Permalink to this headline">¶</a></h4>
<p>As mentioned above, Shyft has it’s own Timeseries class. This class is quite powerful, and the <a class="reference external" href="../api/api-timeseries.ipynb">api-timeseries</a> notebook shows more of the functionality. For now, let’s look at some key aspects, and how to create a quick plot of the individual catchment discharge.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># We can make a quick plot of the data of each sub-catchment</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">20</span><span class="p">,</span><span class="mi">15</span><span class="p">))</span>

<span class="c1"># plot each catchment discharge in the catchment_ids</span>
<span class="k">for</span> <span class="n">i</span><span class="p">,</span><span class="n">cid</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">region_model</span><span class="o">.</span><span class="n">catchment_ids</span><span class="p">):</span>
    <span class="c1"># a ts.time_axis can be enumerated to it&#39;s UtcPeriod,</span>
    <span class="c1"># that will have a .start and .end of type utctimestamp</span>
    <span class="c1"># to use matplotlib support for datetime-axis, we convert it to datetime (as above)</span>
    <span class="n">ts_timestamps</span> <span class="o">=</span> <span class="p">[</span><span class="n">dt</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">utcfromtimestamp</span><span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">start</span><span class="p">)</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">region_model</span><span class="o">.</span><span class="n">time_axis</span><span class="p">]</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">([</span><span class="nb">int</span><span class="p">(</span><span class="n">cid</span><span class="p">)])</span><span class="o">.</span><span class="n">values</span>

    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span><span class="n">data</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">region_model</span><span class="o">.</span><span class="n">catchment_ids</span><span class="p">[</span><span class="n">i</span><span class="p">]))</span>

<span class="n">fig</span><span class="o">.</span><span class="n">autofmt_xdate</span><span class="p">()</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="s2">&quot;Catch. ID&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s2">&quot;discharge [m3 s-1]&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0, 0.5, &#39;discharge [m3 s-1]&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_nea-example_simulation-configured_24_1.png" src="../../_images/notebooks_nea-example_simulation-configured_24_1.png" />
</div>
</div>
</div>
</div>
<div class="section" id="Visualizing-the-distributed-catchment-data">
<h3>Visualizing the distributed catchment data<a class="headerlink" href="#Visualizing-the-distributed-catchment-data" title="Permalink to this headline">¶</a></h3>
<p>An important, but difficult concept, to remember when working with Shyft, is that internally there is no ‘grid’ to speak of. The simulation is vectorized, and each ‘cell’ represents a spatial area with it’s own area and geolocation information. Therefore, we cannot just load a datacube of data, as some may be familiar with.</p>
<p>Visualization of this data is a bit more complex, because each individual cell is in practice an individual polygon. Depending on how the data has been configured for Shyft (see <a class="reference external" href="../../region_model.rst">region_model</a>), the cells may, in fact, be simple squares or more complex shapes. For the visualization below, we simply treat them as uniform size, and plot them with the <code class="docutils literal notranslate"><span class="pre">scatter</span></code> function in matplotlib.</p>
<div class="section" id="Extract-data-for-individual-simulation-cells">
<h4>Extract data for individual simulation cells<a class="headerlink" href="#Extract-data-for-individual-simulation-cells" title="Permalink to this headline">¶</a></h4>
<p>We’ll start by looking at values of individual cells, rather than at the catchment level. Since Shyft does not have an underlying ‘raster’ model, you need to fetch all cells directly from the underlying <code class="docutils literal notranslate"><span class="pre">region_model</span></code>.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">cells</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">get_cells</span><span class="p">()</span>

<span class="c1"># Once we have the cells, we can get their coordinate information</span>
<span class="c1"># and fetch the x- and y-location of the cells</span>
<span class="n">x</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">cell</span><span class="o">.</span><span class="n">geo</span><span class="o">.</span><span class="n">mid_point</span><span class="p">()</span><span class="o">.</span><span class="n">x</span> <span class="k">for</span> <span class="n">cell</span> <span class="ow">in</span> <span class="n">cells</span><span class="p">])</span>
<span class="n">y</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">cell</span><span class="o">.</span><span class="n">geo</span><span class="o">.</span><span class="n">mid_point</span><span class="p">()</span><span class="o">.</span><span class="n">y</span> <span class="k">for</span> <span class="n">cell</span> <span class="ow">in</span> <span class="n">cells</span><span class="p">])</span>
</pre></div>
</div>
</div>
<p>We also will need to get a ‘z’ value to make things interesting. Since this is the first time we’ve visualized our catchment, let’s make a map of the sub-catchments. To do this, the first thing we need to do is get the membership of each cell. That is, to which catchment does it below. We do this by extracting the <code class="docutils literal notranslate"><span class="pre">catchment_id</span></code> of each cell – and this is what we’ll map. The result will be a map of the sub-catchments.</p>
<p>Recall from above we extracted the <code class="docutils literal notranslate"><span class="pre">catchment_id_map</span></code> from the <code class="docutils literal notranslate"><span class="pre">region_model</span></code>:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span># mapping of internal catch ID to catchment
catchment_id_map = simulator.region_model.catchment_id_map
</pre></div>
</div>
<p>We could just use the <code class="docutils literal notranslate"><span class="pre">catchment_id</span></code> as the ‘z’ value, but since this could be a string, we’ll take a different approach. We’ll assign a unique integer to each <code class="docutils literal notranslate"><span class="pre">catchment_id</span></code> and plot those (it is also easier for the color bar scaling).</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[14]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># let&#39;s create the mapping of catchment_id to an integer:</span>
<span class="n">catchment_ids</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">catchment_ids</span>
<span class="n">cid_z_map</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">([</span> <span class="p">(</span><span class="n">catchment_ids</span><span class="p">[</span><span class="n">i</span><span class="p">],</span><span class="n">i</span><span class="p">)</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">catchment_ids</span><span class="p">))])</span>

<span class="c1"># then create an array the same length as our &#39;x&#39; and &#39;y&#39;, which holds the</span>
<span class="c1"># integer value that we&#39;ll use for the &#39;z&#39; value</span>
<span class="n">catch_ids</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">cid_z_map</span><span class="p">[</span><span class="n">cell</span><span class="o">.</span><span class="n">geo</span><span class="o">.</span><span class="n">catchment_id</span><span class="p">()]</span> <span class="k">for</span> <span class="n">cell</span> <span class="ow">in</span> <span class="n">cells</span><span class="p">])</span>

<span class="c1"># and make a quick catchment map...</span>
<span class="c1"># using a scatter plot of the cells</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">5</span><span class="p">))</span>
<span class="n">cm</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">cm</span><span class="o">.</span><span class="n">get_cmap</span><span class="p">(</span><span class="s1">&#39;rainbow&#39;</span><span class="p">)</span>
<span class="n">plot</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="n">catch_ids</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;.&#39;</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mi">40</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">cmap</span><span class="o">=</span><span class="n">cm</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">colorbar</span><span class="p">(</span><span class="n">plot</span><span class="p">)</span><span class="o">.</span><span class="n">set_label</span><span class="p">(</span><span class="s1">&#39;zero-based mapping(proper map tbd)&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_nea-example_simulation-configured_29_0.png" src="../../_images/notebooks_nea-example_simulation-configured_29_0.png" />
</div>
</div>
</div>
</div>
<div class="section" id="Visualing-the-Snow-Cover-Area-of-all-cells-for-a-certain-point-in-time">
<h3>Visualing the Snow Cover Area of all cells for a certain point in time<a class="headerlink" href="#Visualing-the-Snow-Cover-Area-of-all-cells-for-a-certain-point-in-time" title="Permalink to this headline">¶</a></h3>
<p>Here we’ll do some more work to look at a snapshot value of data in each of the cells. This example is collecting the response variable (here the Snow Cover Area (SCA)) for each of the cells for a certain point of time.</p>
<p>The “response collector” is another concept within Shyft that is important keep in mind. We don’t collect and store responses for every variable, in order to keep the simulation memory use lean. Therefore, depending on your application, it may be required to explicitly enable this. The relevant code is found in <code class="docutils literal notranslate"><span class="pre">region_model.h</span></code> in the C++ core source code.</p>
<p>For the <code class="docutils literal notranslate"><span class="pre">ConfigSimulator</span></code> class, which we used to instantiate the <code class="docutils literal notranslate"><span class="pre">simulator</span></code>, a standard collector is used that will provide access to the most relevant variables.</p>
<p>For a model run during calibration, we are use a collector that just does the required minimum for the calibration. And, it is still configurable: we can turn on/off the snow-collection, so if we don’t calibrate for snow, they are not collected. More on calibration is shown in the tutorial: <a class="reference external" href="calibrate_nea_nidelva.ipynb">Calibration with Shyft</a></p>
<p>The state collector used for the ‘highspeed’ calibration models (C++), is a null-collector, so no memory allocated, and no cpu-time used.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[15]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1">#first, set a date: year, month, day, (hour of day if hourly time step)</span>
<span class="n">oslo</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">Calendar</span><span class="p">(</span><span class="s1">&#39;Europe/Oslo&#39;</span><span class="p">)</span> <span class="c1"># specifying input calendar in Oslo tz-id</span>
<span class="n">time_x</span> <span class="o">=</span> <span class="n">oslo</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2014</span><span class="p">,</span><span class="mi">5</span><span class="p">,</span><span class="mi">15</span><span class="p">)</span>  <span class="c1"># the oslo calendar(incl dst) converts calendar coordinates Y,M,D.. to its utc-time</span>

<span class="c1"># we need to get the index of the time_axis for the time</span>
<span class="k">try</span><span class="p">:</span>
    <span class="n">idx</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">time_axis</span><span class="o">.</span><span class="n">index_of</span><span class="p">(</span><span class="n">time_x</span><span class="p">)</span> <span class="c1"># index of time x on time-axis</span>
<span class="k">except</span><span class="p">:</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Date out of range, setting index to 0&quot;</span><span class="p">)</span>
    <span class="n">idx</span> <span class="o">=</span> <span class="mi">0</span>

<span class="c1"># fetching SCA (the response variable is named &quot;snow_sca&quot;)</span>
<span class="c1"># You can use tab-completion to explore the `rc`, short for &quot;response collector&quot;</span>
<span class="c1"># object of the cell, to see further response variables available.</span>
<span class="c1"># specifying empty list [] indicates all catchments, otherwise pass catchment_id</span>
<span class="n">sca</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">gamma_snow_response</span><span class="o">.</span><span class="n">sca</span><span class="p">([],</span><span class="n">idx</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>Let’s take a closer look at this…</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>simulator.region_model.time_axis.index_of(time_x)
</pre></div>
</div>
<p>Simply provided an index value that we can use to index the cells for the time we’re interested in looking at.</p>
<p>Next we use:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>simulator.region_model.gamma_snow_response
</pre></div>
</div>
<p>What is this? This is a collector from the simulation. In this case, for the <code class="docutils literal notranslate"><span class="pre">gamma_snow</span></code> routine. It contains a convenient method to access the response variables from the simulation on a per catchment level. Each response variable (<code class="docutils literal notranslate"><span class="pre">outflow</span></code>, <code class="docutils literal notranslate"><span class="pre">sca</span></code>, <code class="docutils literal notranslate"><span class="pre">swe</span></code>) can be called with two arguments. The first a list of the catchments, and the second an index to the time, as shown above. Note, this will return the values for each cell in the sub-catchment. Maybe one is only interested in the
total <code class="docutils literal notranslate"><span class="pre">outflow</span></code> or total <code class="docutils literal notranslate"><span class="pre">swe</span></code> for the region. In this case you can use: <code class="docutils literal notranslate"><span class="pre">.outflow_value</span></code> which will return a single value.</p>
<p>There is also a response collector for the state variables: <code class="docutils literal notranslate"><span class="pre">.gamma_snow_state</span></code>.</p>
<p>Explore both of these further with tab completion or <code class="docutils literal notranslate"><span class="pre">help</span></code>. As well as the full <code class="docutils literal notranslate"><span class="pre">region_model</span></code> to see what other algorithm collectors are available as this example is configured.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[16]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># for attr in dir(simulator.region_model):</span>
<span class="c1">#     if attr[0] is not &#39;_&#39;: #ignore privates</span>
<span class="c1">#         print(attr)</span>
<span class="c1"># # and don&#39;t forget:</span>
<span class="c1"># help(simulator.region_model.gamma_snow_state)</span>
</pre></div>
</div>
</div>
<p>We are now ready to explore some of the variables from the simulation. We’ll continue on with SCA.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[17]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># We can make a simple scatter plot again for quick visualization</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">5</span><span class="p">))</span>
<span class="n">cm</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">cm</span><span class="o">.</span><span class="n">get_cmap</span><span class="p">(</span><span class="s1">&#39;winter&#39;</span><span class="p">)</span>
<span class="n">plot</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="n">sca</span><span class="p">,</span>
                  <span class="n">vmin</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">vmax</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                  <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;s&#39;</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mi">40</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
                  <span class="n">cmap</span><span class="o">=</span><span class="n">cm</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">colorbar</span><span class="p">(</span><span class="n">plot</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s1">&#39;Snow Covered area of </span><span class="si">{0}</span><span class="s1"> on </span><span class="si">{1}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">cfg</span><span class="o">.</span><span class="n">region_model_id</span><span class="p">,</span> <span class="n">oslo</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="n">time_x</span><span class="p">)))</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[17]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0.5, 1.0, &#39;Snow Covered area of neanidelva-ptgsk on 2014-05-15T00:00:00+02&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_nea-example_simulation-configured_35_1.png" src="../../_images/notebooks_nea-example_simulation-configured_35_1.png" />
</div>
</div>
<div class="section" id="A-note-about-the-geometry-of-the-region">
<h4>A note about the geometry of the region<a class="headerlink" href="#A-note-about-the-geometry-of-the-region" title="Permalink to this headline">¶</a></h4>
<p>Again, keep in mind that while we have created a variable that contains the values for <code class="docutils literal notranslate"><span class="pre">sca</span></code> in each cell, this is only an iterable object. The only reason we know where each value is located is because we have corresponding <code class="docutils literal notranslate"><span class="pre">x</span></code> and <code class="docutils literal notranslate"><span class="pre">y</span></code> values for each cell. It is not an array.</p>
<p>We can calculate some statistics directly out of <code class="docutils literal notranslate"><span class="pre">sca</span></code>:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[18]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># look at the catchment-wide average:</span>
<span class="n">nea_avg_sca</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">average</span><span class="p">(</span><span class="n">sca</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Average SCA for Nea Nidelva: </span><span class="si">{0}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">nea_avg_sca</span><span class="p">))</span>

<span class="c1"># And let&#39;s compute histogram of the snow covered area as well</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">()</span>
<span class="n">ax</span><span class="o">.</span><span class="n">hist</span><span class="p">(</span><span class="n">sca</span><span class="p">,</span> <span class="n">bins</span><span class="o">=</span><span class="mi">20</span><span class="p">,</span> <span class="nb">range</span><span class="o">=</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">),</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;y&#39;</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="mf">0.5</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s2">&quot;SCA of grid cell&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s2">&quot;frequency&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Average SCA for Nea Nidelva: 0.6771728705105866
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[18]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0, 0.5, &#39;frequency&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_nea-example_simulation-configured_37_2.png" src="../../_images/notebooks_nea-example_simulation-configured_37_2.png" />
</div>
</div>
</div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="run_nea_nidelva.html" class="btn btn-neutral float-right" title="A first simulation with Shyft" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="calibration-configured.html" class="btn btn-neutral float-left" title="Running a calibration with SHyFT" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>